t / test-lib.shon commit Merge branch 'jc/cvsserver' into maint-2.10 (31add46)
   1# Test framework for git.  See t/README for usage.
   2#
   3# Copyright (c) 2005 Junio C Hamano
   4#
   5# This program is free software: you can redistribute it and/or modify
   6# it under the terms of the GNU General Public License as published by
   7# the Free Software Foundation, either version 2 of the License, or
   8# (at your option) any later version.
   9#
  10# This program is distributed in the hope that it will be useful,
  11# but WITHOUT ANY WARRANTY; without even the implied warranty of
  12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  13# GNU General Public License for more details.
  14#
  15# You should have received a copy of the GNU General Public License
  16# along with this program.  If not, see http://www.gnu.org/licenses/ .
  17
  18# Test the binaries we have just built.  The tests are kept in
  19# t/ subdirectory and are run in 'trash directory' subdirectory.
  20if test -z "$TEST_DIRECTORY"
  21then
  22        # We allow tests to override this, in case they want to run tests
  23        # outside of t/, e.g. for running tests on the test library
  24        # itself.
  25        TEST_DIRECTORY=$(pwd)
  26else
  27        # ensure that TEST_DIRECTORY is an absolute path so that it
  28        # is valid even if the current working directory is changed
  29        TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
  30fi
  31if test -z "$TEST_OUTPUT_DIRECTORY"
  32then
  33        # Similarly, override this to store the test-results subdir
  34        # elsewhere
  35        TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
  36fi
  37GIT_BUILD_DIR="$TEST_DIRECTORY"/..
  38
  39################################################################
  40# It appears that people try to run tests without building...
  41"$GIT_BUILD_DIR/git" >/dev/null
  42if test $? != 1
  43then
  44        echo >&2 'error: you do not seem to have built git yet.'
  45        exit 1
  46fi
  47
  48. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
  49export PERL_PATH SHELL_PATH
  50
  51# if --tee was passed, write the output not only to the terminal, but
  52# additionally to the file test-results/$BASENAME.out, too.
  53case "$GIT_TEST_TEE_STARTED, $* " in
  54done,*)
  55        # do not redirect again
  56        ;;
  57*' --tee '*|*' --va'*|*' --verbose-log '*)
  58        mkdir -p "$TEST_OUTPUT_DIRECTORY/test-results"
  59        BASE="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)"
  60
  61        # Make this filename available to the sub-process in case it is using
  62        # --verbose-log.
  63        GIT_TEST_TEE_OUTPUT_FILE=$BASE.out
  64        export GIT_TEST_TEE_OUTPUT_FILE
  65
  66        # Truncate before calling "tee -a" to get rid of the results
  67        # from any previous runs.
  68        >"$GIT_TEST_TEE_OUTPUT_FILE"
  69
  70        (GIT_TEST_TEE_STARTED=done ${SHELL_PATH} "$0" "$@" 2>&1;
  71         echo $? >"$BASE.exit") | tee -a "$GIT_TEST_TEE_OUTPUT_FILE"
  72        test "$(cat "$BASE.exit")" = 0
  73        exit
  74        ;;
  75esac
  76
  77# For repeatability, reset the environment to known value.
  78# TERM is sanitized below, after saving color control sequences.
  79LANG=C
  80LC_ALL=C
  81PAGER=cat
  82TZ=UTC
  83export LANG LC_ALL PAGER TZ
  84EDITOR=:
  85# A call to "unset" with no arguments causes at least Solaris 10
  86# /usr/xpg4/bin/sh and /bin/ksh to bail out.  So keep the unsets
  87# deriving from the command substitution clustered with the other
  88# ones.
  89unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
  90        my @env = keys %ENV;
  91        my $ok = join("|", qw(
  92                TRACE
  93                DEBUG
  94                USE_LOOKUP
  95                TEST
  96                .*_TEST
  97                PROVE
  98                VALGRIND
  99                UNZIP
 100                PERF_
 101                CURL_VERBOSE
 102                TRACE_CURL
 103        ));
 104        my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
 105        print join("\n", @vars);
 106')
 107unset XDG_CONFIG_HOME
 108unset GITPERLLIB
 109GIT_AUTHOR_EMAIL=author@example.com
 110GIT_AUTHOR_NAME='A U Thor'
 111GIT_COMMITTER_EMAIL=committer@example.com
 112GIT_COMMITTER_NAME='C O Mitter'
 113GIT_MERGE_VERBOSITY=5
 114GIT_MERGE_AUTOEDIT=no
 115export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
 116export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
 117export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
 118export EDITOR
 119
 120# Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
 121GIT_TRACE_BARE=1
 122export GIT_TRACE_BARE
 123
 124if test -n "${TEST_GIT_INDEX_VERSION:+isset}"
 125then
 126        GIT_INDEX_VERSION="$TEST_GIT_INDEX_VERSION"
 127        export GIT_INDEX_VERSION
 128fi
 129
 130# Add libc MALLOC and MALLOC_PERTURB test
 131# only if we are not executing the test with valgrind
 132if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
 133   test -n "$TEST_NO_MALLOC_CHECK"
 134then
 135        setup_malloc_check () {
 136                : nothing
 137        }
 138        teardown_malloc_check () {
 139                : nothing
 140        }
 141else
 142        setup_malloc_check () {
 143                MALLOC_CHECK_=3 MALLOC_PERTURB_=165
 144                export MALLOC_CHECK_ MALLOC_PERTURB_
 145        }
 146        teardown_malloc_check () {
 147                unset MALLOC_CHECK_ MALLOC_PERTURB_
 148        }
 149fi
 150
 151: ${ASAN_OPTIONS=detect_leaks=0}
 152export ASAN_OPTIONS
 153
 154# Protect ourselves from common misconfiguration to export
 155# CDPATH into the environment
 156unset CDPATH
 157
 158unset GREP_OPTIONS
 159unset UNZIP
 160
 161case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
 1621|2|true)
 163        GIT_TRACE=4
 164        ;;
 165esac
 166
 167# Convenience
 168#
 169# A regexp to match 5 and 40 hexdigits
 170_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
 171_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
 172
 173# Zero SHA-1
 174_z40=0000000000000000000000000000000000000000
 175
 176EMPTY_TREE=4b825dc642cb6eb9a060e54bf8d69288fbee4904
 177EMPTY_BLOB=e69de29bb2d1d6434b8b29ae775ad8c2e48c5391
 178
 179# Line feed
 180LF='
 181'
 182
 183# UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
 184# when case-folding filenames
 185u200c=$(printf '\342\200\214')
 186
 187export _x05 _x40 _z40 LF u200c EMPTY_TREE EMPTY_BLOB
 188
 189# Each test should start with something like this, after copyright notices:
 190#
 191# test_description='Description of this test...
 192# This test checks if command xyzzy does the right thing...
 193# '
 194# . ./test-lib.sh
 195test "x$TERM" != "xdumb" && (
 196                test -t 1 &&
 197                tput bold >/dev/null 2>&1 &&
 198                tput setaf 1 >/dev/null 2>&1 &&
 199                tput sgr0 >/dev/null 2>&1
 200        ) &&
 201        color=t
 202
 203while test "$#" -ne 0
 204do
 205        case "$1" in
 206        -d|--d|--de|--deb|--debu|--debug)
 207                debug=t; shift ;;
 208        -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
 209                immediate=t; shift ;;
 210        -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
 211                GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
 212        -r)
 213                shift; test "$#" -ne 0 || {
 214                        echo 'error: -r requires an argument' >&2;
 215                        exit 1;
 216                }
 217                run_list=$1; shift ;;
 218        --run=*)
 219                run_list=${1#--*=}; shift ;;
 220        -h|--h|--he|--hel|--help)
 221                help=t; shift ;;
 222        -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
 223                verbose=t; shift ;;
 224        --verbose-only=*)
 225                verbose_only=${1#--*=}
 226                shift ;;
 227        -q|--q|--qu|--qui|--quie|--quiet)
 228                # Ignore --quiet under a TAP::Harness. Saying how many tests
 229                # passed without the ok/not ok details is always an error.
 230                test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
 231        --with-dashes)
 232                with_dashes=t; shift ;;
 233        --no-color)
 234                color=; shift ;;
 235        --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
 236                valgrind=memcheck
 237                shift ;;
 238        --valgrind=*)
 239                valgrind=${1#--*=}
 240                shift ;;
 241        --valgrind-only=*)
 242                valgrind_only=${1#--*=}
 243                shift ;;
 244        --tee)
 245                shift ;; # was handled already
 246        --root=*)
 247                root=${1#--*=}
 248                shift ;;
 249        --chain-lint)
 250                GIT_TEST_CHAIN_LINT=1
 251                shift ;;
 252        --no-chain-lint)
 253                GIT_TEST_CHAIN_LINT=0
 254                shift ;;
 255        -x)
 256                trace=t
 257                verbose=t
 258                shift ;;
 259        --verbose-log)
 260                verbose_log=t
 261                shift ;;
 262        *)
 263                echo "error: unknown test option '$1'" >&2; exit 1 ;;
 264        esac
 265done
 266
 267if test -n "$valgrind_only"
 268then
 269        test -z "$valgrind" && valgrind=memcheck
 270        test -z "$verbose" && verbose_only="$valgrind_only"
 271elif test -n "$valgrind"
 272then
 273        verbose=t
 274fi
 275
 276if test -n "$color"
 277then
 278        # Save the color control sequences now rather than run tput
 279        # each time say_color() is called.  This is done for two
 280        # reasons:
 281        #   * TERM will be changed to dumb
 282        #   * HOME will be changed to a temporary directory and tput
 283        #     might need to read ~/.terminfo from the original HOME
 284        #     directory to get the control sequences
 285        # Note:  This approach assumes the control sequences don't end
 286        # in a newline for any terminal of interest (command
 287        # substitutions strip trailing newlines).  Given that most
 288        # (all?) terminals in common use are related to ECMA-48, this
 289        # shouldn't be a problem.
 290        say_color_error=$(tput bold; tput setaf 1) # bold red
 291        say_color_skip=$(tput setaf 4) # blue
 292        say_color_warn=$(tput setaf 3) # brown/yellow
 293        say_color_pass=$(tput setaf 2) # green
 294        say_color_info=$(tput setaf 6) # cyan
 295        say_color_reset=$(tput sgr0)
 296        say_color_="" # no formatting for normal text
 297        say_color () {
 298                test -z "$1" && test -n "$quiet" && return
 299                eval "say_color_color=\$say_color_$1"
 300                shift
 301                printf "%s\\n" "$say_color_color$*$say_color_reset"
 302        }
 303else
 304        say_color() {
 305                test -z "$1" && test -n "$quiet" && return
 306                shift
 307                printf "%s\n" "$*"
 308        }
 309fi
 310
 311TERM=dumb
 312export TERM
 313
 314error () {
 315        say_color error "error: $*"
 316        GIT_EXIT_OK=t
 317        exit 1
 318}
 319
 320say () {
 321        say_color info "$*"
 322}
 323
 324if test -n "$HARNESS_ACTIVE"
 325then
 326        if test "$verbose" = t || test -n "$verbose_only"
 327        then
 328                printf 'Bail out! %s\n' \
 329                 'verbose mode forbidden under TAP harness; try --verbose-log'
 330                exit 1
 331        fi
 332fi
 333
 334test "${test_description}" != "" ||
 335error "Test script did not set test_description."
 336
 337if test "$help" = "t"
 338then
 339        printf '%s\n' "$test_description"
 340        exit 0
 341fi
 342
 343exec 5>&1
 344exec 6<&0
 345if test "$verbose_log" = "t"
 346then
 347        exec 3>>"$GIT_TEST_TEE_OUTPUT_FILE" 4>&3
 348elif test "$verbose" = "t"
 349then
 350        exec 4>&2 3>&1
 351else
 352        exec 4>/dev/null 3>/dev/null
 353fi
 354
 355# Send any "-x" output directly to stderr to avoid polluting tests
 356# which capture stderr. We can do this unconditionally since it
 357# has no effect if tracing isn't turned on.
 358#
 359# Note that this sets up the trace fd as soon as we assign the variable, so it
 360# must come after the creation of descriptor 4 above. Likewise, we must never
 361# unset this, as it has the side effect of closing descriptor 4, which we
 362# use to show verbose tests to the user.
 363#
 364# Note also that we don't need or want to export it. The tracing is local to
 365# this shell, and we would not want to influence any shells we exec.
 366BASH_XTRACEFD=4
 367
 368test_failure=0
 369test_count=0
 370test_fixed=0
 371test_broken=0
 372test_success=0
 373
 374test_external_has_tap=0
 375
 376die () {
 377        code=$?
 378        if test -n "$GIT_EXIT_OK"
 379        then
 380                exit $code
 381        else
 382                echo >&5 "FATAL: Unexpected exit with code $code"
 383                exit 1
 384        fi
 385}
 386
 387GIT_EXIT_OK=
 388trap 'die' EXIT
 389trap 'exit $?' INT
 390
 391# The user-facing functions are loaded from a separate file so that
 392# test_perf subshells can have them too
 393. "$TEST_DIRECTORY/test-lib-functions.sh"
 394
 395# You are not expected to call test_ok_ and test_failure_ directly, use
 396# the test_expect_* functions instead.
 397
 398test_ok_ () {
 399        test_success=$(($test_success + 1))
 400        say_color "" "ok $test_count - $@"
 401}
 402
 403test_failure_ () {
 404        test_failure=$(($test_failure + 1))
 405        say_color error "not ok $test_count - $1"
 406        shift
 407        printf '%s\n' "$*" | sed -e 's/^/#      /'
 408        test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
 409}
 410
 411test_known_broken_ok_ () {
 412        test_fixed=$(($test_fixed+1))
 413        say_color error "ok $test_count - $@ # TODO known breakage vanished"
 414}
 415
 416test_known_broken_failure_ () {
 417        test_broken=$(($test_broken+1))
 418        say_color warn "not ok $test_count - $@ # TODO known breakage"
 419}
 420
 421test_debug () {
 422        test "$debug" = "" || eval "$1"
 423}
 424
 425match_pattern_list () {
 426        arg="$1"
 427        shift
 428        test -z "$*" && return 1
 429        for pattern_
 430        do
 431                case "$arg" in
 432                $pattern_)
 433                        return 0
 434                esac
 435        done
 436        return 1
 437}
 438
 439match_test_selector_list () {
 440        title="$1"
 441        shift
 442        arg="$1"
 443        shift
 444        test -z "$1" && return 0
 445
 446        # Both commas and whitespace are accepted as separators.
 447        OLDIFS=$IFS
 448        IFS='   ,'
 449        set -- $1
 450        IFS=$OLDIFS
 451
 452        # If the first selector is negative we include by default.
 453        include=
 454        case "$1" in
 455                !*) include=t ;;
 456        esac
 457
 458        for selector
 459        do
 460                orig_selector=$selector
 461
 462                positive=t
 463                case "$selector" in
 464                        !*)
 465                                positive=
 466                                selector=${selector##?}
 467                                ;;
 468                esac
 469
 470                test -z "$selector" && continue
 471
 472                case "$selector" in
 473                        *-*)
 474                                if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null
 475                                then
 476                                        echo "error: $title: invalid non-numeric in range" \
 477                                                "start: '$orig_selector'" >&2
 478                                        exit 1
 479                                fi
 480                                if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null
 481                                then
 482                                        echo "error: $title: invalid non-numeric in range" \
 483                                                "end: '$orig_selector'" >&2
 484                                        exit 1
 485                                fi
 486                                ;;
 487                        *)
 488                                if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null
 489                                then
 490                                        echo "error: $title: invalid non-numeric in test" \
 491                                                "selector: '$orig_selector'" >&2
 492                                        exit 1
 493                                fi
 494                esac
 495
 496                # Short cut for "obvious" cases
 497                test -z "$include" && test -z "$positive" && continue
 498                test -n "$include" && test -n "$positive" && continue
 499
 500                case "$selector" in
 501                        -*)
 502                                if test $arg -le ${selector#-}
 503                                then
 504                                        include=$positive
 505                                fi
 506                                ;;
 507                        *-)
 508                                if test $arg -ge ${selector%-}
 509                                then
 510                                        include=$positive
 511                                fi
 512                                ;;
 513                        *-*)
 514                                if test ${selector%%-*} -le $arg \
 515                                        && test $arg -le ${selector#*-}
 516                                then
 517                                        include=$positive
 518                                fi
 519                                ;;
 520                        *)
 521                                if test $arg -eq $selector
 522                                then
 523                                        include=$positive
 524                                fi
 525                                ;;
 526                esac
 527        done
 528
 529        test -n "$include"
 530}
 531
 532maybe_teardown_verbose () {
 533        test -z "$verbose_only" && return
 534        exec 4>/dev/null 3>/dev/null
 535        verbose=
 536}
 537
 538last_verbose=t
 539maybe_setup_verbose () {
 540        test -z "$verbose_only" && return
 541        if match_pattern_list $test_count $verbose_only
 542        then
 543                exec 4>&2 3>&1
 544                # Emit a delimiting blank line when going from
 545                # non-verbose to verbose.  Within verbose mode the
 546                # delimiter is printed by test_expect_*.  The choice
 547                # of the initial $last_verbose is such that before
 548                # test 1, we do not print it.
 549                test -z "$last_verbose" && echo >&3 ""
 550                verbose=t
 551        else
 552                exec 4>/dev/null 3>/dev/null
 553                verbose=
 554        fi
 555        last_verbose=$verbose
 556}
 557
 558maybe_teardown_valgrind () {
 559        test -z "$GIT_VALGRIND" && return
 560        GIT_VALGRIND_ENABLED=
 561}
 562
 563maybe_setup_valgrind () {
 564        test -z "$GIT_VALGRIND" && return
 565        if test -z "$valgrind_only"
 566        then
 567                GIT_VALGRIND_ENABLED=t
 568                return
 569        fi
 570        GIT_VALGRIND_ENABLED=
 571        if match_pattern_list $test_count $valgrind_only
 572        then
 573                GIT_VALGRIND_ENABLED=t
 574        fi
 575}
 576
 577want_trace () {
 578        test "$trace" = t && test "$verbose" = t
 579}
 580
 581# This is a separate function because some tests use
 582# "return" to end a test_expect_success block early
 583# (and we want to make sure we run any cleanup like
 584# "set +x").
 585test_eval_inner_ () {
 586        # Do not add anything extra (including LF) after '$*'
 587        eval "
 588                want_trace && set -x
 589                $*"
 590}
 591
 592test_eval_ () {
 593        # We run this block with stderr redirected to avoid extra cruft
 594        # during a "-x" trace. Once in "set -x" mode, we cannot prevent
 595        # the shell from printing the "set +x" to turn it off (nor the saving
 596        # of $? before that). But we can make sure that the output goes to
 597        # /dev/null.
 598        #
 599        # The test itself is run with stderr put back to &4 (so either to
 600        # /dev/null, or to the original stderr if --verbose was used).
 601        {
 602                test_eval_inner_ "$@" </dev/null >&3 2>&4
 603                test_eval_ret_=$?
 604                if want_trace
 605                then
 606                        set +x
 607                        if test "$test_eval_ret_" != 0
 608                        then
 609                                say_color error >&4 "error: last command exited with \$?=$test_eval_ret_"
 610                        fi
 611                fi
 612        } 2>/dev/null
 613        return $test_eval_ret_
 614}
 615
 616test_run_ () {
 617        test_cleanup=:
 618        expecting_failure=$2
 619
 620        if test "${GIT_TEST_CHAIN_LINT:-1}" != 0; then
 621                # turn off tracing for this test-eval, as it simply creates
 622                # confusing noise in the "-x" output
 623                trace_tmp=$trace
 624                trace=
 625                # 117 is magic because it is unlikely to match the exit
 626                # code of other programs
 627                test_eval_ "(exit 117) && $1"
 628                if test "$?" != 117; then
 629                        error "bug in the test script: broken &&-chain: $1"
 630                fi
 631                trace=$trace_tmp
 632        fi
 633
 634        setup_malloc_check
 635        test_eval_ "$1"
 636        eval_ret=$?
 637        teardown_malloc_check
 638
 639        if test -z "$immediate" || test $eval_ret = 0 ||
 640           test -n "$expecting_failure" && test "$test_cleanup" != ":"
 641        then
 642                setup_malloc_check
 643                test_eval_ "$test_cleanup"
 644                teardown_malloc_check
 645        fi
 646        if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
 647        then
 648                echo ""
 649        fi
 650        return "$eval_ret"
 651}
 652
 653test_start_ () {
 654        test_count=$(($test_count+1))
 655        maybe_setup_verbose
 656        maybe_setup_valgrind
 657}
 658
 659test_finish_ () {
 660        echo >&3 ""
 661        maybe_teardown_valgrind
 662        maybe_teardown_verbose
 663}
 664
 665test_skip () {
 666        to_skip=
 667        skipped_reason=
 668        if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
 669        then
 670                to_skip=t
 671                skipped_reason="GIT_SKIP_TESTS"
 672        fi
 673        if test -z "$to_skip" && test -n "$test_prereq" &&
 674           ! test_have_prereq "$test_prereq"
 675        then
 676                to_skip=t
 677
 678                of_prereq=
 679                if test "$missing_prereq" != "$test_prereq"
 680                then
 681                        of_prereq=" of $test_prereq"
 682                fi
 683                skipped_reason="missing $missing_prereq${of_prereq}"
 684        fi
 685        if test -z "$to_skip" && test -n "$run_list" &&
 686                ! match_test_selector_list '--run' $test_count "$run_list"
 687        then
 688                to_skip=t
 689                skipped_reason="--run"
 690        fi
 691
 692        case "$to_skip" in
 693        t)
 694                say_color skip >&3 "skipping test: $@"
 695                say_color skip "ok $test_count # skip $1 ($skipped_reason)"
 696                : true
 697                ;;
 698        *)
 699                false
 700                ;;
 701        esac
 702}
 703
 704# stub; perf-lib overrides it
 705test_at_end_hook_ () {
 706        :
 707}
 708
 709test_done () {
 710        GIT_EXIT_OK=t
 711
 712        if test -z "$HARNESS_ACTIVE"
 713        then
 714                test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
 715                mkdir -p "$test_results_dir"
 716                base=${0##*/}
 717                test_results_path="$test_results_dir/${base%.sh}.counts"
 718
 719                cat >"$test_results_path" <<-EOF
 720                total $test_count
 721                success $test_success
 722                fixed $test_fixed
 723                broken $test_broken
 724                failed $test_failure
 725
 726                EOF
 727        fi
 728
 729        if test "$test_fixed" != 0
 730        then
 731                say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
 732        fi
 733        if test "$test_broken" != 0
 734        then
 735                say_color warn "# still have $test_broken known breakage(s)"
 736        fi
 737        if test "$test_broken" != 0 || test "$test_fixed" != 0
 738        then
 739                test_remaining=$(( $test_count - $test_broken - $test_fixed ))
 740                msg="remaining $test_remaining test(s)"
 741        else
 742                test_remaining=$test_count
 743                msg="$test_count test(s)"
 744        fi
 745        case "$test_failure" in
 746        0)
 747                # Maybe print SKIP message
 748                if test -n "$skip_all" && test $test_count -gt 0
 749                then
 750                        error "Can't use skip_all after running some tests"
 751                fi
 752                test -z "$skip_all" || skip_all=" # SKIP $skip_all"
 753
 754                if test $test_external_has_tap -eq 0
 755                then
 756                        if test $test_remaining -gt 0
 757                        then
 758                                say_color pass "# passed all $msg"
 759                        fi
 760                        say "1..$test_count$skip_all"
 761                fi
 762
 763                test -d "$remove_trash" &&
 764                cd "$(dirname "$remove_trash")" &&
 765                rm -rf "$(basename "$remove_trash")"
 766
 767                test_at_end_hook_
 768
 769                exit 0 ;;
 770
 771        *)
 772                if test $test_external_has_tap -eq 0
 773                then
 774                        say_color error "# failed $test_failure among $msg"
 775                        say "1..$test_count"
 776                fi
 777
 778                exit 1 ;;
 779
 780        esac
 781}
 782
 783if test -n "$valgrind"
 784then
 785        make_symlink () {
 786                test -h "$2" &&
 787                test "$1" = "$(readlink "$2")" || {
 788                        # be super paranoid
 789                        if mkdir "$2".lock
 790                        then
 791                                rm -f "$2" &&
 792                                ln -s "$1" "$2" &&
 793                                rm -r "$2".lock
 794                        else
 795                                while test -d "$2".lock
 796                                do
 797                                        say "Waiting for lock on $2."
 798                                        sleep 1
 799                                done
 800                        fi
 801                }
 802        }
 803
 804        make_valgrind_symlink () {
 805                # handle only executables, unless they are shell libraries that
 806                # need to be in the exec-path.
 807                test -x "$1" ||
 808                test "# " = "$(head -c 2 <"$1")" ||
 809                return;
 810
 811                base=$(basename "$1")
 812                case "$base" in
 813                test-*)
 814                        symlink_target="$GIT_BUILD_DIR/t/helper/$base"
 815                        ;;
 816                *)
 817                        symlink_target="$GIT_BUILD_DIR/$base"
 818                        ;;
 819                esac
 820                # do not override scripts
 821                if test -x "$symlink_target" &&
 822                    test ! -d "$symlink_target" &&
 823                    test "#!" != "$(head -c 2 < "$symlink_target")"
 824                then
 825                        symlink_target=../valgrind.sh
 826                fi
 827                case "$base" in
 828                *.sh|*.perl)
 829                        symlink_target=../unprocessed-script
 830                esac
 831                # create the link, or replace it if it is out of date
 832                make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
 833        }
 834
 835        # override all git executables in TEST_DIRECTORY/..
 836        GIT_VALGRIND=$TEST_DIRECTORY/valgrind
 837        mkdir -p "$GIT_VALGRIND"/bin
 838        for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/t/helper/test-*
 839        do
 840                make_valgrind_symlink $file
 841        done
 842        # special-case the mergetools loadables
 843        make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
 844        OLDIFS=$IFS
 845        IFS=:
 846        for path in $PATH
 847        do
 848                ls "$path"/git-* 2> /dev/null |
 849                while read file
 850                do
 851                        make_valgrind_symlink "$file"
 852                done
 853        done
 854        IFS=$OLDIFS
 855        PATH=$GIT_VALGRIND/bin:$PATH
 856        GIT_EXEC_PATH=$GIT_VALGRIND/bin
 857        export GIT_VALGRIND
 858        GIT_VALGRIND_MODE="$valgrind"
 859        export GIT_VALGRIND_MODE
 860        GIT_VALGRIND_ENABLED=t
 861        test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
 862        export GIT_VALGRIND_ENABLED
 863elif test -n "$GIT_TEST_INSTALLED"
 864then
 865        GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
 866        error "Cannot run git from $GIT_TEST_INSTALLED."
 867        PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
 868        GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
 869else # normal case, use ../bin-wrappers only unless $with_dashes:
 870        git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
 871        if ! test -x "$git_bin_dir/git"
 872        then
 873                if test -z "$with_dashes"
 874                then
 875                        say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
 876                fi
 877                with_dashes=t
 878        fi
 879        PATH="$git_bin_dir:$PATH"
 880        GIT_EXEC_PATH=$GIT_BUILD_DIR
 881        if test -n "$with_dashes"
 882        then
 883                PATH="$GIT_BUILD_DIR:$PATH"
 884        fi
 885fi
 886GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
 887GIT_CONFIG_NOSYSTEM=1
 888GIT_ATTR_NOSYSTEM=1
 889export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
 890
 891if test -z "$GIT_TEST_CMP"
 892then
 893        if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
 894        then
 895                GIT_TEST_CMP="$DIFF -c"
 896        else
 897                GIT_TEST_CMP="$DIFF -u"
 898        fi
 899fi
 900
 901GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
 902export GITPERLLIB
 903test -d "$GIT_BUILD_DIR"/templates/blt || {
 904        error "You haven't built things yet, have you?"
 905}
 906
 907if ! test -x "$GIT_BUILD_DIR"/t/helper/test-chmtime
 908then
 909        echo >&2 'You need to build test-chmtime:'
 910        echo >&2 'Run "make t/helper/test-chmtime" in the source (toplevel) directory'
 911        exit 1
 912fi
 913
 914# Test repository
 915TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
 916test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
 917case "$TRASH_DIRECTORY" in
 918/*) ;; # absolute path is good
 919 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
 920esac
 921test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
 922rm -fr "$TRASH_DIRECTORY" || {
 923        GIT_EXIT_OK=t
 924        echo >&5 "FATAL: Cannot prepare test area"
 925        exit 1
 926}
 927
 928HOME="$TRASH_DIRECTORY"
 929GNUPGHOME="$HOME/gnupg-home-not-used"
 930export HOME GNUPGHOME
 931
 932if test -z "$TEST_NO_CREATE_REPO"
 933then
 934        test_create_repo "$TRASH_DIRECTORY"
 935else
 936        mkdir -p "$TRASH_DIRECTORY"
 937fi
 938# Use -P to resolve symlinks in our working directory so that the cwd
 939# in subprocesses like git equals our $PWD (for pathname comparisons).
 940cd -P "$TRASH_DIRECTORY" || exit 1
 941
 942this_test=${0##*/}
 943this_test=${this_test%%-*}
 944if match_pattern_list "$this_test" $GIT_SKIP_TESTS
 945then
 946        say_color info >&3 "skipping test $this_test altogether"
 947        skip_all="skip all tests in $this_test"
 948        test_done
 949fi
 950
 951# Provide an implementation of the 'yes' utility
 952yes () {
 953        if test $# = 0
 954        then
 955                y=y
 956        else
 957                y="$*"
 958        fi
 959
 960        i=0
 961        while test $i -lt 99
 962        do
 963                echo "$y"
 964                i=$(($i+1))
 965        done
 966}
 967
 968# Fix some commands on Windows
 969case $(uname -s) in
 970*MINGW*)
 971        # Windows has its own (incompatible) sort and find
 972        sort () {
 973                /usr/bin/sort "$@"
 974        }
 975        find () {
 976                /usr/bin/find "$@"
 977        }
 978        sum () {
 979                md5sum "$@"
 980        }
 981        # git sees Windows-style pwd
 982        pwd () {
 983                builtin pwd -W
 984        }
 985        # no POSIX permissions
 986        # backslashes in pathspec are converted to '/'
 987        # exec does not inherit the PID
 988        test_set_prereq MINGW
 989        test_set_prereq NATIVE_CRLF
 990        test_set_prereq SED_STRIPS_CR
 991        test_set_prereq GREP_STRIPS_CR
 992        GIT_TEST_CMP=mingw_test_cmp
 993        ;;
 994*CYGWIN*)
 995        test_set_prereq POSIXPERM
 996        test_set_prereq EXECKEEPSPID
 997        test_set_prereq CYGWIN
 998        test_set_prereq SED_STRIPS_CR
 999        test_set_prereq GREP_STRIPS_CR
1000        ;;
1001*)
1002        test_set_prereq POSIXPERM
1003        test_set_prereq BSLASHPSPEC
1004        test_set_prereq EXECKEEPSPID
1005        ;;
1006esac
1007
1008( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
1009test -z "$NO_PERL" && test_set_prereq PERL
1010test -z "$NO_PYTHON" && test_set_prereq PYTHON
1011test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
1012test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1013
1014# Can we rely on git's output in the C locale?
1015if test -n "$GETTEXT_POISON"
1016then
1017        GIT_GETTEXT_POISON=YesPlease
1018        export GIT_GETTEXT_POISON
1019        test_set_prereq GETTEXT_POISON
1020else
1021        test_set_prereq C_LOCALE_OUTPUT
1022fi
1023
1024# Use this instead of test_cmp to compare files that contain expected and
1025# actual output from git commands that can be translated.  When running
1026# under GETTEXT_POISON this pretends that the command produced expected
1027# results.
1028test_i18ncmp () {
1029        test -n "$GETTEXT_POISON" || test_cmp "$@"
1030}
1031
1032# Use this instead of "grep expected-string actual" to see if the
1033# output from a git command that can be translated either contains an
1034# expected string, or does not contain an unwanted one.  When running
1035# under GETTEXT_POISON this pretends that the command produced expected
1036# results.
1037test_i18ngrep () {
1038        if test -n "$GETTEXT_POISON"
1039        then
1040            : # pretend success
1041        elif test "x!" = "x$1"
1042        then
1043                shift
1044                ! grep "$@"
1045        else
1046                grep "$@"
1047        fi
1048}
1049
1050test_lazy_prereq PIPE '
1051        # test whether the filesystem supports FIFOs
1052        case $(uname -s) in
1053        CYGWIN*|MINGW*)
1054                false
1055                ;;
1056        *)
1057                rm -f testfifo && mkfifo testfifo
1058                ;;
1059        esac
1060'
1061
1062test_lazy_prereq SYMLINKS '
1063        # test whether the filesystem supports symbolic links
1064        ln -s x y && test -h y
1065'
1066
1067test_lazy_prereq FILEMODE '
1068        test "$(git config --bool core.filemode)" = true
1069'
1070
1071test_lazy_prereq CASE_INSENSITIVE_FS '
1072        echo good >CamelCase &&
1073        echo bad >camelcase &&
1074        test "$(cat CamelCase)" != good
1075'
1076
1077test_lazy_prereq UTF8_NFD_TO_NFC '
1078        # check whether FS converts nfd unicode to nfc
1079        auml=$(printf "\303\244")
1080        aumlcdiar=$(printf "\141\314\210")
1081        >"$auml" &&
1082        case "$(echo *)" in
1083        "$aumlcdiar")
1084                true ;;
1085        *)
1086                false ;;
1087        esac
1088'
1089
1090test_lazy_prereq AUTOIDENT '
1091        sane_unset GIT_AUTHOR_NAME &&
1092        sane_unset GIT_AUTHOR_EMAIL &&
1093        git var GIT_AUTHOR_IDENT
1094'
1095
1096test_lazy_prereq EXPENSIVE '
1097        test -n "$GIT_TEST_LONG"
1098'
1099
1100test_lazy_prereq USR_BIN_TIME '
1101        test -x /usr/bin/time
1102'
1103
1104test_lazy_prereq NOT_ROOT '
1105        uid=$(id -u) &&
1106        test "$uid" != 0
1107'
1108
1109# SANITY is about "can you correctly predict what the filesystem would
1110# do by only looking at the permission bits of the files and
1111# directories?"  A typical example of !SANITY is running the test
1112# suite as root, where a test may expect "chmod -r file && cat file"
1113# to fail because file is supposed to be unreadable after a successful
1114# chmod.  In an environment (i.e. combination of what filesystem is
1115# being used and who is running the tests) that lacks SANITY, you may
1116# be able to delete or create a file when the containing directory
1117# doesn't have write permissions, or access a file even if the
1118# containing directory doesn't have read or execute permissions.
1119
1120test_lazy_prereq SANITY '
1121        mkdir SANETESTD.1 SANETESTD.2 &&
1122
1123        chmod +w SANETESTD.1 SANETESTD.2 &&
1124        >SANETESTD.1/x 2>SANETESTD.2/x &&
1125        chmod -w SANETESTD.1 &&
1126        chmod -r SANETESTD.1/x &&
1127        chmod -rx SANETESTD.2 ||
1128        error "bug in test sript: cannot prepare SANETESTD"
1129
1130        ! test -r SANETESTD.1/x &&
1131        ! rm SANETESTD.1/x && ! test -f SANETESTD.2/x
1132        status=$?
1133
1134        chmod +rwx SANETESTD.1 SANETESTD.2 &&
1135        rm -rf SANETESTD.1 SANETESTD.2 ||
1136        error "bug in test sript: cannot clean SANETESTD"
1137        return $status
1138'
1139
1140GIT_UNZIP=${GIT_UNZIP:-unzip}
1141test_lazy_prereq UNZIP '
1142        "$GIT_UNZIP" -v
1143        test $? -ne 127
1144'
1145
1146run_with_limited_cmdline () {
1147        (ulimit -s 128 && "$@")
1148}
1149
1150test_lazy_prereq CMDLINE_LIMIT 'run_with_limited_cmdline true'
1151
1152build_option () {
1153        git version --build-options |
1154        sed -ne "s/^$1: //p"
1155}
1156
1157test_lazy_prereq LONG_IS_64BIT '
1158        test 8 -le "$(build_option sizeof-long)"
1159'